<!DOCTYPE html>
<html>
  <head>
    <meta charset="utf-8" />
    <title>FLex Panels</title>
    <link href="https://fonts.googleapis.com/css?family=Amatic+SC" rel="stylesheet" type="text/css" />
  </head>
  <body>
    <style>
      html {
        box-sizing: border-box;
        background: #ffc600;
        font-family: "helvetica neue";
        font-size: 20px;
        font-weight: 200;
      }
      body {
        margin: 0;
      }
      *,
      *:before,
      *:after {
        box-sizing: inherit;
      }
      .panels {
        min-height: 100vh;
        overflow: hidden;
        /* display flex 을 통해, panel 들을 가로로 배치*/
        display: flex;
      }
      .panel {
        z-index: 999;
        display: flex;
        flex-direction: column;
        justify-content: center;
        align-items: center;
        background: #6b0f9c;
        flex: 1;
        box-shadow: inset 0 0 0 5px rgba(255, 255, 255, 0.1);
        color: white;
        text-align: center;
        /* transform 에 의해 촉발되는 요소 */
        transition: font-size 0.7s cubic-bezier(0.61, -0.19, 0.7, -0.11),
          flex 0.7s cubic-bezier(0.61, -0.19, 0.7, -0.11), background 0.2s;
        font-size: 20px;
        background-size: cover;
        background-position: center;
      }
      .panel1 {
        background-image: url(https://source.unsplash.com/gYl-UtwNg_I/1500x1500);
      }
      .panel2 {
        background-image: url(https://source.unsplash.com/1CD3fd8kHnE/1500x1500);
      }
      .panel3 {
        background-image: url(https://images.unsplash.com/photo-1465188162913-8fb5709d6d57?ixlib=rb-0.3.5&q=80&fm=jpg&crop=faces&cs=tinysrgb&w=1500&h=1500&fit=crop&s=967e8a713a4e395260793fc8c802901d);
      }
      .panel4 {
        background-image: url(https://source.unsplash.com/ITjiVXcwVng/1500x1500);
      }
      .panel5 {
        background-image: url(https://source.unsplash.com/3MNzGlQM7qs/1500x1500);
      }

      .panel > * {
        margin: 0;
        width: 100%;
        transition: transform 0.5s;
        flex: 1 0 auto;
        display: flex;
        justify-content: center;
        align-items: center;
      }

      /* 위아래 내용을 최초에는 안보이게 함 */
      .panel > *:first-child {
        transform: translateY(-100%);
      }
      .panel > *:last-child {
        transform: translateY(100%);
      }

      .panel.open-active > *:first-child {
        transform: translateY(0);
      }
      .panel.open-active > *:last-child {
        transform: translateY(0);
      }

      .panel p {
        text-transform: uppercase;
        font-family: "Amatic SC", cursive;
        text-shadow: 0 0 4px rgba(0, 0, 0, 0.72), 0 0 14px rgba(0, 0, 0, 0.45);
        font-size: 2em;
      }
      /* panel 밑에 있는 두번째 p 마다, 글자크기 다르게*/
      .panel p:nth-child(2) {
        font-size: 4em;
      }
      .panel.open {
        flex: 5;
        font-size: 40px;
      }
    </style>
    <article class="panels">
      <div class="panel panel1">
        <p>Hey</p>
        <p>Let's</p>
        <p>Dance</p>
      </div>
      <div class="panel panel2">
        <p>Give</p>
        <p>Take</p>
        <p>Receive</p>
      </div>
      <div class="panel panel3">
        <p>Experience</p>
        <p>It</p>
        <p>Today</p>
      </div>
      <div class="panel panel4">
        <p>Give</p>
        <p>All</p>
        <p>You can</p>
      </div>
      <div class="panel panel5">
        <p>Life</p>
        <p>In</p>
        <p>Motion</p>
      </div>
    </article>

    <script>
      const panelsContainer = document.querySelector(".panels");

      // 이벤트 리스너 내부 함수 이므로
      // evnet 객체 접근 가능!
      function toggleOpen() {
        event.preventDefault;

        // console.log(event.target);
        // div(panel) 나 p 의 DOM 을 잡아냄
        const clickedChildNode = event.target.nodeName == "DIV" ? event.target : event.target.parentNode;

        clickedChildNode.classList.toggle("open");
        setTimeout(function () {
          clickedChildNode.classList.toggle("open-active");
        }, 600);
      }

      // 아티클 클릭시 반응
      panelsContainer.addEventListener("click", toggleOpen);
    </script>
  </body>
</html>
